# Copyright (c) 2000-2002 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
"""
functions usefull to generate unit tests
"""

__revision__ = "$Id: testutils.py,v 1.1 2002/06/13 13:41:30 alf Exp $"

from logilab.pyreverse.base.lib import time_tag
from cStringIO import StringIO

def open_unittest(pgm, name, header='', cvs_vars=[('__revision__', 'Id', '')],
                  doc=''):
    cvs_string = ''
    for var_title, cvs_var, select in cvs_vars:
        cvs_string = '%s%s = "$%s:$"%s\n' % (
            cvs_string, var_title, cvs_var, select)
    
    return '''%s"""
unit tests for module %s
squeleton generated by %s on %s

%s
"""
%s
import unittest
from %s import *'''% (header, name, pgm, time_tag(), doc, cvs_string, name)

def close_unittest(tests_list):
    buffer = StringIO()
    buffer.write('''

    
def Run():
    testsuite = unittest.TestSuite()''')
    for klass, func in tests_list:
        buffer.write('''
    testsuite.addTest(%s("%s"))'''%(klass, func))
    buffer.write('''
    test = unittest.TextTestRunner()
    # uncomment next line to write tests results in a file
    #test.__init__(open('tests.log','w+'))    
    return test.run(testsuite)
    
if __name__ == '__main__':
    Run()''')
    return buffer.getvalue()

def open_testcase(name, doc='', setup='pass', teardown='pass'):
    return '''

    
class %s(unittest.TestCase):
    """%s"""
    def setUp(self):
        """ called before each test from this class """
        %s

    def tearDown(self):
        """ called after each test from this class """
        %s''' % (name, doc, setup, teardown)

def open_func(name):
    return '''
    
    def %s(self):''' % (name)

def assert_(expression, msg='Assertion failed'):
    return '''
        self.assert_(%s, %s)''' % (expression, msg)

def assert_equal(first, second, msg=None):
    return '''
        self.assertEqual(%s, %s, %s)''' % (first, second, msg)

def assert_raise(exception, object):
    return '''
        self.assertRaises(%s, %s)''' % (exception, object)

def whatever(line):
    return '''
        %s''' % line

def wrap_file(file):
    f = open(file)
    buffer = StringIO()
    for line in f.readlines():
        buffer.write('# %s'%line)
    f.close()
    return buffer.getvalue()

