# Copyright (c) 2000-2002 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
"""
"""

__revision__ = "$Id: py2tests.py,v 1.7 2003/02/18 16:57:19 syt Exp $"

def Run():
    import sys
    import config
    for arg in config.get_default_options():
        sys.argv.insert(1, arg)
    from optik import OptionParser
    from base import pyparser
    opt_parser = OptionParser("""USAGE: %prog [options]
parse python sources files and generate unittests from them""")
    # add standard options
    pyparser.set_options(opt_parser)
    # add specific options
    opt_parser.add_option("-d", "--test-dir", action="store", type='string',
                          dest="test_dir", default='test',
                          help="put generated test in <directory>.",
                          metavar="<directory>")
    opt_parser.add_option("-l", "--header-file", action="store", type='string',
                          dest="header", default='',
                          help="insert commented content of <file> in each tests file generated (for instance, licence).",
                          metavar="<file>")
    (options, args) = opt_parser.parse_args()
    if not args:
        print opt_parser.print_help()
        return

    from visitors.test_generator import UnittestGeneratorVisitor
    if options.header:
        from extensions.testutils import wrap_file
        options.header = options.wrap_file(options.header)
    if not test_dir in options.black_list:
        options.black_list.append(test_dir)
    if not 'setup.py' in options.black_list:
        options.black_list.append(test_dir)
    parser = pyparser.PyParser(options.black_list,
                               options.filter_func,
                               options.init_only)
    p = parser.parse_all(args, project)
    visitor = UnittestGeneratorVisitor(options.test_dir, options.header, options.filter_func)
    visitor.visit(p)
    
if __name__ == "__main__":
    Run()
