"""
convert the class hierarchy describing the project to XMI 1.0 UML 1.3
"""

__revision__ = "$Id: py2xmi_uml.py,v 1.7 2003/02/26 11:59:24 syt Exp $"

import sys

def output_callback(option, opt, val, parser):
    parser.values.output = open(val, 'w')
    
def Run():
    import config
    for arg in config.get_default_options():
        sys.argv.insert(1, arg)
    from optik import OptionParser
    from base import pyparser
    opt_parser = OptionParser("""USAGE: %prog [options]
parse python sources files and extract an XMI UML file from them""")
    # add standard options
    pyparser.set_options(opt_parser)
    # add specific options
    opt_parser.add_option("-o", "--output", action="callback", type='string',
                          dest="output", default=sys.stdout, callback=output_callback,
                          help="write output to <file> instead of stdout.",
                          metavar="<file>")
    (options, args) = opt_parser.parse_args()
    if not args:
        print opt_parser.print_help()
        return

    from xml.dom.ext import PrettyPrint
    from visitors.xmi_uml import XMIUMLVisitor
    parser = pyparser.PyParser(options.black_list,
                               options.filter_func,
                               options.init_only)
    p = parser.parse_all(args, project)
    visitor = XMIUMLVisitor(options.filter_func)
    d = visitor.visit(p, parser.id_count)
    PrettyPrint(d, options.output)
    
if __name__ == "__main__":
    Run()



