# Copyright (c) 2000-2002 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
""" print useful statistic about the project """

__revision__ = '$Id: pystats.py,v 1.10 2003/02/18 16:44:29 syt Exp $'

from visitors.stats import StatsVisitor, print_stats

def Run():
    import config
    import sys
    for arg in config.get_default_options():
        sys.argv.insert(1, arg)
        
    from optik import OptionParser
    from base import pyparser
    opt_parser = OptionParser("""USAGE: %prog [options]
parse python sources files and extract some statistics and a tree of imported modules""")
    # add standard options
    pyparser.set_options(opt_parser)
    # add specific options
    opt_parser.add_option("-v", "--verbose", action="count",
                          dest="verbose", default=0,
                          help="print the maximum information")
    (options, args) = opt_parser.parse_args()
    if not args:
        print opt_parser.print_help()
        return

    parser = pyparser.PyParser(options.black_list,
                               options.filter_func,
                               options.init_only)
    p = parser.parse_all(args, project)
    visitor = StatsVisitor()
    stats = visitor.visit(p)
    print_stats(p, stats, verbose=options.verbose)
    
if __name__ == "__main__":
    Run()

    
