"""
unit tests for module logilab.pyreverse.base.pyparser
squeleton generated by /home/syt/bin/py2tests on Jun 03 at 23:19:31


tranform python code in a classes hierarchy which describes it
the orginal parser is borrowed from pypasax

"""
__revision__ = "$Id: regrtest_pyparser.py,v 1.2 2002/09/25 09:32:52 syt Exp $"

import unittest
from logilab.pyreverse.base.pyparser import *

    
class PyParser_ClassTest(unittest.TestCase):
    """
    python code parse, using the parser library
    """
    def setUp(self):
        """ called before each test from this class """
        self.o = PyParser()

    def parse_all_knownValues_1(self):
        """
        parse a list of files:
        _ enter recursivly in directories which does not appear in black list
          and construct a list with all files to parse
        _ filter files which doesn't end with '.py' or CVS directories
        _ call _parse_all on the result files list
        """
        p = self.o.parse_all(['data'], 'Test project')
        # get some pointers in the tree
        clientmodule = p.children[0]
        suppliermodule = p.children[1]
        notimplemented = suppliermodule.children[0]
        interface = suppliermodule.children[1]
        donothing = suppliermodule.children[2]
        iface_getvalue = interface.children[0]
        ancestor = clientmodule.children[0]
        ancestor_init = ancestor.children[0]
        ancestor_attr = ancestor.children[1]
        ancestor___value = ancestor.children[2]
        ancestor_getval = ancestor.children[3]
        ancestor_setval = ancestor.children[4]
        specialization = clientmodule.children[1]
        specialization_TYPE = specialization.children[0]
        specialization_top = specialization.children[1]
        specialization__id = specialization.children[3]#.children[0]
        specialization_relation = specialization.children[4]
        # base interface
        self.assertEqual(p.TYPE, 'project')
        self.assertEqual(p.id, 1)
        self.assertEqual(p.name, 'Test project')
        self.assertEqual(p.parent, None)
        # should have parsed 2 module: clientmodule_test and suppliermodule_test
        self.assertEqual(len(p.children), 2)
        self.assertEqual(p.children[1].parent, p)
        self.assertEqual(len(p.children), 2)
        self.assertEqual(len(p.children), 2)
        self.assertEqual(clientmodule.TYPE, 'module')
        self.assertEqual(clientmodule.name, 'data.clientmodule_test')
        self.assertEqual(clientmodule.doc, ' docstring for file clientmodule.py ')
        self.assertEqual(specialization__id.TYPE, 'attribute')
        # attributes triggered by regular expressions
        self.assertEqual(notimplemented.signal, 'true')
        self.assertEqual(specialization_TYPE.type, 'class')
        self.assertEqual(specialization_top.type, 'class')
        self.assertEqual(specialization__id.type, 'instance')
        self.assertEqual(specialization_TYPE.final, 'true')
        self.assertEqual(specialization_top.final, 'false')
        self.assertEqual(specialization__id.visibility, 'protected')
        self.assertEqual(ancestor___value.visibility, 'private')
        self.assertEqual(ancestor_attr.visibility, 'public')
        self.assertEqual(interface.type, 'interface')
        # relationships between nodes
        self.assertEqual(clientmodule.imports[0][0], interface)
        self.assertEqual(clientmodule.imports[0][1], 'IFace')
        self.assertEqual(specialization.parents[0], ancestor)
        self.assertEqual(specialization, ancestor.subclasses[0])
        self.assertEqual(specialization_relation.default, donothing)
        self.assertEqual(iface_getvalue.raises[0], notimplemented)
        # more specific cases
        self.assertEqual(ancestor.doc, ' Ancestor method ')
        self.assertEqual(ancestor_init.doc, '')
        self.assertEqual(ancestor_getval.doc, ' nice docstring ;-) ')
        self.assertEqual(ancestor_setval.doc, '')
        

    
def Run():
    testsuite = unittest.TestSuite()
    testsuite.addTest(PyParser_ClassTest("parse_all_knownValues_1"))

    test = unittest.TextTestRunner()
    # uncomment next line to write tests results in a file
    #test.__init__(open('unittest.log','w+'))    
    return test.run(testsuite)
    
#    unittest.main()
    
if __name__ == '__main__':
    Run()
