"""
unit tests for module logilab.pyreverse.visitors.xmi_uml
squeleton generated by /home/syt/bin/py2tests on Jun 04 at 12:16:36


convert the class hierarchy describing the project to XMI 1.0 UML 1.3
DOM representation

please notices that it is based on file generated by ArgoUML

"""
__revision__ = "$Id: regrtest_xmi_uml.py,v 1.2 2002/09/25 09:32:52 syt Exp $"

import unittest
from logilab.pyreverse.visitors.xmi_uml import XMIUMLVisitor
from logilab.pyreverse.base.pyparser import PyParser

    
class XMIUMLVisitor_ClassTest(unittest.TestCase):
    """
    generate a dom tree conform to the XMI-1.0 UML-1.3 DTD from the project

    check that the generated dom is conform to the DTD
    """
    def setUp(self):
        """ called before each test from this class """
        self.o = XMIUMLVisitor()
    
    def knownValues_visit(self):
        parser = PyParser()
        p = parser.parse_all(['data'], 'Test project')
        d = self.o.visit(p, parser.id_count)
        from os.path import join
        from xml.dom.ext import PrettyPrint
        path = join('generated', 'Test_project.xmi')
        f = open(path, 'w+')
        PrettyPrint(d, f)
        f.close()
        from xml.parsers.xmlproc import xmlval, xmlproc, _outputters
        p = xmlval.XMLValidator()
        err = _outputters.MyErrorHandler(p, p.parser,
                                         warnings=1, entstack=0,
                                         rawxml=0)
        p.set_error_handler(err)
        p.set_application(xmlproc.Application())
        p.parse_resource(path)
        self.assertEqual(err.errors, 0)
        self.assertEqual(err.warnings, 0)
    


    
def Run():
    testsuite = unittest.TestSuite()
    testsuite.addTest(XMIUMLVisitor_ClassTest("knownValues_visit"))
    test = unittest.TextTestRunner()
    # uncomment next line to write tests results in a file
    #test.__init__(open('tests.log','w+'))    
    return test.run(testsuite)
    
if __name__ == '__main__':
    Run()
